SystemOrganization addCategory: #'AAS.lu-Pier-WidgetAdaptors'!

!PRKernelSettings methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 13:49'!
initialize
	super initialize.
	component := self kernel asComponent.
	
	self context command isWidgetAdaptor
		ifFalse: [component addForm]
		ifTrue: [	component addForm: (Array 
											with: #apply
											with: ([:aContainerComponent | self answer: nil]->'Close'))].
	component addValidation! !

!PUUser methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 1/30/2010 21:07'!
beMasterUser
	^self propertyAt: #masterUser put: true! !

!PUUser methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 1/30/2010 21:09'!
isMasterUser
	^self propertyAt: #masterUser ifAbsent: [false]! !

!PRExportImportWidget methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 12:57'!
renderContentOn: html
	self renderExportOn: html.
	self renderImportOn: html.
	self context command isWidgetAdaptor ifFalse: [^self]. 
	html form: [
		html paragraph: [
			html submitButton
				callback: [ self answer: nil];
				with: 'Close' ] ]
! !

!PRSystemWidget methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 13:30'!
renderContentOn: html
	html preformatted: SmalltalkImage current vmStatisticsReportString.
	self isSuperuser ifTrue: [ self renderActionsOn: html ].
	
	self context command isWidgetAdaptor ifFalse: [^self]. 
	html form: [
		html paragraph: [
			html submitButton
				callback: [ self answer: nil];
				with: 'Close' ] ]
	! !

PRDistribution subclass: #AAsWidgetAdaptorsDistribution
	instanceVariableNames: 'admintoolsPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsWidgetAdaptorsDistribution class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/20/2010 23:04'!
title
	"override this method to name the design"
	^'Widget Adaptor'! !

!AAsWidgetAdaptorsDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/21/2010 10:31'!
admintoolsPage

      | adminComp |
	admintoolsPage ifNotNil: [^admintoolsPage].

       adminComp := PRComponent named: 'widget'.
       adminComp 
		componentClass: PRCommandsWidget;
            write: AAsWidgetAdaptorCommand allAdminToolCommands
		using: PRCommandsWidget descriptionCommandClasses.

       admintoolsPage:= (PRPage named: 'admintools') 
               addChild: adminComp;
               contents: 'Admin tools: +widget+';
               yourself.

       ^admintoolsPage
! !

!AAsWidgetAdaptorsDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/20/2010 22:29'!
commandsPage

	| c |
	commandsPage ifNotNil: [^commandsPage].
	commandsPage := PRPage named: 'commands'.
	commandsPage
		addChild: (c := (PRComponent named: 'widget') 
						componentClass: PRCommandsWidget; 
						yourself);
		contents: 'Commands: +widget+'.
		
	c
		write: (PRCommand allSubclasses
				select: [:aCmdClass | aCmdClass isAdminTool not])
		using: PRCommandsWidget descriptionCommandClasses.

	^commandsPage		
	! !

!AAsWidgetAdaptorsDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/24/2010 11:29'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
		contents:
'{{{<div class="footer column span-24 last">
	<div class="column span-18">
		}}}+/system/components/justlogincommand+
		+/system/components/loggedinuser+{{{
		<div class="commands">}}}+/system/components/admintools+{{{</div>
		<div class="sitemap">}}}+/system/components/sitemap+{{{</div>
	</div>
	<div class="column span-6 last">}}}+/system/components/poweredby+{{{</div>
</div>}}}';
		yourself
	]! !

!AAsWidgetAdaptorsDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/24/2010 11:29'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
		contents:
'{{{<div class="header">
	<div class="container">
		<div class="column span-24 header">
			<div class="menu column span-18">}}}+/system/components/menu|menu+{{{</div>
		</div>
	</div>
</div>
<div class="footer column span-24 last">
	<div class="column span-18">
		<div class="commands">}}}+/system/components/commands+{{{</div>
		<div class="views">}}}+/system/components/views+{{{</div>
	</div>
</div>}}}
';
		yourself
	]! !

!AAsWidgetAdaptorsDistribution methodsFor: 'rights' stamp: 'razavi@acm.org 2/20/2010 23:02'!
makeMasterRestricted: aStructure
	"Master nodes are only accessible to the root."
	aStructure securityDecoration owner: self kernel masterUser.
	aStructure securityDecoration ownerPermissions: PUChangeSecurity permissionInstances.
	
	aStructure securityDecoration group: self kernel adminGroup.
	aStructure securityDecoration groupPermissions: #(). 
	
	aStructure securityDecoration otherPermissions: #().
! !

!AAsWidgetAdaptorsDistribution methodsFor: 'creation' stamp: 'razavi@acm.org 2/20/2010 23:02'!
root
	super root.
	self componentsPage addChild: self admintoolsPage.
	self makeMasterRestricted: self admintoolsPage.
	^ self rootPage! !

!AAsWidgetAdaptorsDistribution methodsFor: 'structures' stamp: 'razavi@acm.org 2/20/2010 23:16'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier')
		title: 'Welcome to Pier!!';
		yourself.

		rootPage 
		contents:
'This is the main page of the official Pier distribution. Before you can modify this site, you have to login using: 
- ""admin/pier"", to access to the standard ''command'' and ''views'' toolbars.
- ""master/root"", to access to the additional ''system administration'' toolbar.

If you are not satisfied with the current look, perhaps you want to choose another one:

+/system/components/designchooser+

Have fun!!

The Pier Team
'.
		rootPage]! !

!PRPersistencySettings methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 13:25'!
renderContentOn: html
	html form: [
		html select
			labels: [ :each | each label ];
			selected: self kernel persistency class;
			list: PRPersistency withAllConcreteClasses;
			callback: [ :each | self activate: each ].
		html space.
		html submitButton
			with: 'select'.
		5 timesRepeat: [ html space ].
		html submitButton
			callback: [ self edit: self kernel persistency ];
			disabled: self kernel persistency description isEmpty;
			with: 'edit'.
		(self kernel persistency respondsTo: #snapshot) ifTrue: [
			html space.
			html submitButton
				callback: [ self kernel persistency snapshot ];
				text: 'snapshot' ] ].
	html paragraph: self kernel persistency class comment.
	
	self context command isWidgetAdaptor ifFalse: [^self]. 
	html form: [
		html paragraph: [
			html submitButton
				callback: [ self answer: nil];
				with: 'Close' ] ]
! !

PRCommand subclass: #AAsWidgetAdaptorCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

AAsWidgetAdaptorCommand subclass: #AAsEditUserCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsEditUserCommand class methodsFor: 'testing' stamp: 'razavi@acm.org 2/19/2010 16:40'!
isAdminTool
	^false! !

!AAsEditUserCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:39'!
widgetClass
	^PUSecurityWidget! !

!AAsEditUserCommand methodsFor: 'converting' stamp: 'razavi@acm.org 9/9/2009 13:24'!
asComponent
	"Answer a compoent to configure the edit operation of the receiver. This does not require to be a Magritte component, but in most cases it is."
	"Adopted from PUSecurityWidget"
	| component |
	component := (self context user description
		select: [ :each | each hasProperty: #public ])
			asComponentOn: self context user.
	component
		addValidatedForm;
		addMessage: 'Edit User'.
	^component! !

AAsWidgetAdaptorCommand subclass: #AAsExportImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsExportImportCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:42'!
widgetClass
	^PRExportImportWidget! !

AAsWidgetAdaptorCommand subclass: #AAsFileSettingsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsFileSettingsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/15/2010 18:41'!
widgetClass
	^PRFileSettings! !

!AAsFileSettingsCommand methodsFor: 'converting' stamp: 'razavi@acm.org 2/15/2010 18:48'!
asComponent
	"Answer a compoent to configure the edit operation of the receiver. This does not require to be a Magritte component, but in most cases it is."

	^super asComponent children first! !

AAsWidgetAdaptorCommand subclass: #AAsGroupsSettingsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsGroupsSettingsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 12:38'!
widgetClass
	^PUGroupsWidget! !

AAsWidgetAdaptorCommand subclass: #AAsKernelSettingsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsKernelSettingsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:09'!
widgetClass
	^PRKernelSettings! !

AAsWidgetAdaptorCommand subclass: #AAsPersistencySettingsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsPersistencySettingsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:23'!
widgetClass
	^PRPersistencySettings! !

AAsWidgetAdaptorCommand subclass: #AAsSystemStatisticsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsSystemStatisticsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:27'!
widgetClass
	^PRSystemWidget! !

AAsWidgetAdaptorCommand subclass: #AAsUsersSettingsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AAS.lu-Pier-WidgetAdaptors'!

!AAsUsersSettingsCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/18/2010 13:31'!
widgetClass
	^PUUsersWidget! !

!AAsWidgetAdaptorCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/21/2010 10:31'!
allAdminToolCommands
	^AAsWidgetAdaptorCommand allSubclasses select: [:aCmdClass | aCmdClass isAdminTool]! !

!AAsWidgetAdaptorCommand class methodsFor: 'testing' stamp: 'razavi@acm.org 2/15/2010 18:40'!
isAbstract
	^self == AAsWidgetAdaptorCommand! !

!AAsWidgetAdaptorCommand class methodsFor: 'testing' stamp: 'razavi@acm.org 2/19/2010 16:40'!
isAdminTool
	^true! !

!AAsWidgetAdaptorCommand class methodsFor: 'testing' stamp: 'razavi@acm.org 2/20/2010 22:58'!
isValidIn: aContext
	"Verify that a command as a meaning for the context aContext. Override this command to add new constraints that are static to the command."

	aContext user ifNil: [^false].
	^aContext user isMasterUser 
	"^super isValidIn: aContext"! !

!AAsWidgetAdaptorCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/15/2010 18:37'!
label
	^self widgetClass label! !

!AAsWidgetAdaptorCommand class methodsFor: 'accessing' stamp: 'razavi@acm.org 2/15/2010 18:37'!
widgetClass
	^self subclassresponsibility! !

!AAsWidgetAdaptorCommand methodsFor: 'converting' stamp: 'razavi@acm.org 2/18/2010 15:35'!
asComponent
	"Answer a compoent to configure the edit operation of the receiver. This does not require to be a Magritte component, but in most cases it is."
	
	^self widgetHolder componentFor: nil.! !

!AAsWidgetAdaptorCommand methodsFor: 'testing' stamp: 'razavi@acm.org 2/18/2010 13:06'!
isWidgetAdaptor
	^true! !

!AAsWidgetAdaptorCommand methodsFor: 'private' stamp: 'razavi@acm.org 2/18/2010 15:37'!
widgetHolder
	^(PRComponent named: 'hack') componentClass: self class widgetClass; yourself! !

!PRCommand class methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/19/2010 16:39'!
isAdminTool
	^false! !

!PRCommand methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 12:56'!
isWidgetAdaptor
	^false! !

!PUMemberWidget methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/18/2010 12:57'!
renderContentOn: html
	self renderReportOn: html.
	self renderAddOn: html.
	"Added by RRA"
	self context command isWidgetAdaptor ifFalse: [^self]. 
	html form: [
		html paragraph: [
			html submitButton
				callback: [ self answer: nil];
				with: 'Close' ] ]
! !

!PRKernel methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/20/2010 22:54'!
masterUser
	^ self propertyAt: #masterUser ifAbsentPut: [
		(PUUser named: 'master')
			addGroup: self adminGroup;
			password: 'root';
			superuser: true;
			beMasterUser;
			yourself ]! !

!PRKernel methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/20/2010 22:55'!
users
	^ self propertyAt: #users ifAbsentPut: [ Set with: self adminUser with: self masterUser ]! !

!GRPackage class methodsFor: '*aas.lu-pier-widgetAdaptors' stamp: 'razavi@acm.org 2/27/2010 08:43'!
aasPierWidgetAdaptors 
	^ self new
		name: 'AAS.lu-Pier-WidgetAdaptors';
		description: 'Packages Pier system management facilities as commands, and shows how to integrate them into Pier distributions.';
		addDependency: 'Pier-Setup';
		url: #pierAddonsUrl;
		yourself! !
